package com.zopim.android.sdk.anim;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.animation.AnimatorSet;
import android.animation.ObjectAnimator;
import android.annotation.TargetApi;
import android.app.Activity;
import android.graphics.Rect;
import android.os.Build;
import android.view.View;
import com.zendesk.logger.Logger;
import java.util.ArrayList;
import java.util.List;

/**
 * Provides useful animator packs.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class AnimatorPack {

    public enum Direction {

        LEFT, TOP, RIGHT, BOTTOM
    }

    /**
     * Scales view in place
     * It's up to you to set view's visibility on animation end
     *
     * @param view to be scaled
     * @param from starting scale
     * @param to   ending scale
     * @return scale animator
     */
    public static AnimatorSet scale(View view, float from, float to) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Switch views with fade and scale in place animation.
     *
     * @param out view to hide
     * @param in  view to show
     * @param outListener that listens for fade-out animator
     * @param inListener that listens for fade-in animator
     * @return crossfade animator
     */
    public static AnimatorSet crossfade(final View out, final View in, Animator.AnimatorListener outListener, Animator.AnimatorListener inListener) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Switch views with fade and scale in place animation.
     *
     * @param out view to hide
     * @param in  view to show
     * @return crossfade animator
     */
    public static AnimatorSet crossfade(final View out, final View in) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Builds a slide out animator.
     *
     * @param toAnimate view to animate
     * @param to        direction to slide out
     * @return slide out animator
     */
    public static Animator slideOut(final View toAnimate, Direction to) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Builds a slide in animator
     *
     * @param toAnimate view to animate
     * @param from      direction to slide in from
     * @return slide in animator
     */
    public static Animator slideIn(final View toAnimate, Direction from) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Slide out animation that delays start of each animated element by an offset.
     *
     * @param to        direction to slide out to
     * @param delay     duration
     * @param fadeOut   true if fading out
     * @param scale     true if scaling
     * @param toAnimate view to animate
     * @return slide out animator
     */
    public static Animator slideOutSequentially(Direction to, long delay, boolean fadeOut, boolean scale, View... toAnimate) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Slide in animation that delays start of each animated element by an offset.
     *
     * @param from      direction to slide in from
     * @param delay     duration
     * @param fadeIn    true if fading in
     * @param scale     true if scaling
     * @param toAnimate view to animate
     * @return slide in animator
     */
    public static Animator slideInSequentially(Direction from, long delay, boolean fadeIn, boolean scale, View... toAnimate) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Animation to fade out and scale down a view and make it invisible.
     *
     * @param toAnimate view to animate
     * @return animator that performs animation
     */
    public static Animator fadeOut(final View toAnimate) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Animation to fade in and scale up a view and make it visible.
     *
     * @param toAnimate view to animate
     * @return animator that performs animation
     */
    public static Animator fadeIn(final View toAnimate) {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }
}
