package com.zopim.android.sdk.embeddable;

import com.zopim.android.sdk.prechat.ZopimChatActivity;
import com.zopim.android.sdk.widget.ChatWidgetService;

/**
 * Definition of intent actions for chat sdk embeddable.
 *
 * @see android.content.Intent
 */
public interface ChatActions {

    /**
     * Defines the action for stopping {@link ChatWidgetService}.
     * <p>
     * Used to notify the chat widget that it should stop.
     * </p>
     */
    String ACTION_STOP_WIDGET_SERVICE = "STOP_WIDGET_SERVICE";

    /**
     * Defines the action for resuming chat.
     * <p>
     * Used by {@link ChatWidgetService} to broadcast an intent to resume the backgrounded chat UI.
     * It the intent with this action does not get intercepted it will be handled by the {@link ZopimChatActivity} as a default.
     * </p>
     */
    String ACTION_RESUME_CHAT = "zopim.action.RESUME_CHAT";
}
