package com.zopim.android.sdk.embeddable;

import com.zopim.android.sdk.BuildConfig;

/**
 * Contract definition for chat sdk embeddable.
 * <p>
 * Serves as an integration contract that integrating projects can use to verify the Chat SDK presence at runtime.
 * </p>
 * <p>
 * CHANGES TO THIS CONTRACT ARE LIKELY TO BREAK THE INTEGRATION - DO NOT MODIFY.
 * </p>
 */
@SuppressWarnings("unused")
public final class Contract {

    /**
     * Defines the action for open ticket intent.
     * <p>
     * Used to notify the host component which embeds the chat that there is an intention to create a ticket request.
     * It the intent with this action does not get intercepted it will be handled by the Chat SDK as a default.
     * </p>
     */
    public static final String ACTION_CREATE_REQUEST = "zopim.action.CREATE_REQUEST";

    /**
     * Defines extras that can be passed via intent with action {@link Contract#ACTION_CREATE_REQUEST}
     */
    public static final String EXTRA_NAME = "com.zopim.EXTRA_NAME";

    public static final String EXTRA_EMAIL = "com.zopim.EXTRA_EMAIL";

    public static final String EXTRA_MESSAGE = "com.zopim.EXTRA_MESSAGE";

    /**
     * Gets version name of the chat sdk as specified in the build.gradle project build file
     *
     * @return version name
     * <p>
     * DO NOT MODIFY
     * </p>
     */
    public static String getChatSdkVersionName() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }
}
