package com.zopim.android.sdk.prechat;

import com.zopim.android.sdk.api.Chat;

/**
 * Interface definition of chat events.
 * <p>
 * Implement this interface in the host activity that embeds {@link ZopimChatFragment} to listen for events defined in this interface.
 * </p>
 */
public interface ChatListener {

    /**
     * Callback that is invoked when {@link ZopimChatFragment} is finished loading the {@link com.zopim.android.sdk.api.Chat}.
     * <p>
     * This will deliver the chat instance that was started by {@link ZopimChatFragment}
     * </p>
     *
     * @param chat instance that was started by {@link ZopimChatFragment}
     */
    void onChatLoaded(Chat chat);

    /**
     * Callback which notifies that {@link com.zopim.android.sdk.api.ChatApi} chat is initialized and ready to be used.
     */
    void onChatInitialized();

    /**
     * Callback that notifies that the chat has ended
     */
    void onChatEnded();
}
