package com.zopim.android.sdk.prechat;

import android.support.annotation.NonNull;
import java.io.Serializable;

/**
 * Pre chat form definition
 * <p>
 * Used to define the form's fields as defined in {@link PreChatForm.Field}
 * </p>
 */
public class PreChatForm implements Serializable {

    /**
     * Gets name filed configuration.
     * Configuration types defined in {@link PreChatForm.Field}
     *
     * @return name field configuration
     */
    @NonNull
    public Field getName() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Gets email filed configuration.
     * Configuration types defined in {@link PreChatForm.Field}
     *
     * @return email field configuration
     */
    @NonNull
    public Field getEmail() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Gets phone number filed configuration.
     * Configuration types defined in {@link PreChatForm.Field}
     *
     * @return phoneNumber field configuration
     */
    @NonNull
    public Field getPhoneNumber() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Gets department filed configuration.
     * Configuration types defined in {@link PreChatForm.Field}
     *
     * @return department field configuration
     */
    @NonNull
    public Field getDepartment() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Gets message filed configuration.
     * Configuration types defined in {@link PreChatForm.Field}
     *
     * @return message field configuration
     */
    @NonNull
    public Field getMessage() {
        // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
        throw new java.lang.RuntimeException("Source removed");
    }

    /**
     * Defines available pre chat form field configurations.
     * <ul>
     * <li>{@link Field#NOT_REQUIRED} Data is not required</li>
     * <li>{@link Field#OPTIONAL} Data should be requested if not known but is not required</li>
     * <li>{@link Field#REQUIRED} Data must be complete to start a chat</li>
     * <li>{@link Field#OPTIONAL_EDITABLE} Data should be requested if not known but is not required</li>
     * <li>{@link Field#REQUIRED_EDITABLE} Data must be complete to start a chat</li>
     * </ul>
     */
    public enum Field {

        /**
         * Data is not required.
         */
        NOT_REQUIRED,
        /**
         * Data should be requested if not known but is not required.
         * Once this data is known it will not be presented for editing by the user.
         */
        OPTIONAL,
        /**
         * Data must be complete to start a chat.
         * Once this data is known it will not be presented for editing by the user.
         */
        REQUIRED,
        /**
         * Data should be requested if not known but is not required.
         * The user will be offered the opportunity to edit this data each time they start a chat.
         */
        OPTIONAL_EDITABLE,
        /**
         * Data must be complete to start a chat.
         * The user will be offered the opportunity to edit this data each time they start a chat.
         */
        REQUIRED_EDITABLE
    }

    /**
     * Builds pre chat form with default of hidden if not specified
     */
    public static class Builder {

        /**
         * Configures name field
         *
         * @param field configuration
         * @return builder
         */
        @NonNull
        public Builder name(@NonNull Field field) {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }

        /**
         * Configures email field
         *
         * @param field configuration
         * @return builder
         */
        @NonNull
        public Builder email(@NonNull Field field) {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }

        /**
         * Configures phone number field
         *
         * @param field configuration
         * @return builder
         */
        @NonNull
        public Builder phoneNumber(@NonNull Field field) {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }

        /**
         * Configures department field
         *
         * @param field configuration
         * @return builder
         */
        @NonNull
        public Builder department(@NonNull Field field) {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }

        /**
         * Configures message field
         *
         * @param field configuration
         * @return builder
         */
        @NonNull
        public Builder message(@NonNull Field field) {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }

        /**
         * Builds pre chat form instance with specified configuration
         *
         * @return pre chat form
         */
        @NonNull
        public PreChatForm build() {
            // This code was redacted by Java Censor - Learn more about it at https://github.com/schlan/java-censor
            throw new java.lang.RuntimeException("Source removed");
        }
    }
}
